namespace Syntriax.Engine.Core;

/// <summary>
/// Represents a <see cref="IBehaviour"/> to be notified when the draw phase of the <see cref="IUniverse"/> occurs.
/// </summary>
public interface IDraw : IBehaviour
{
    /// <summary>
    /// Calls draw logic for the <see cref="IBehaviour"/> to be displayed visually.
    /// </summary>
    void Draw();
}
