using Syntriax.Engine.Core;

namespace Syntriax.Engine.Systems.Tween;

public interface ITween
{
    Event<ITween> OnStarted { get; }
    Event<ITween> OnPaused { get; }
    Event<ITween> OnResumed { get; }
    Event<ITween> OnCancelled { get; }
    Event<ITween> OnCompleted { get; }
    Event<ITween> OnEnded { get; }

    Event<ITween> OnUpdated { get; }
    Event<ITween, TweenDeltaArguments> OnDeltaUpdated { get; }

    TweenState State { get; set; }

    float Counter { get; }
    float Duration { get; }
    float Progress { get; }
    float Value { get; }

    readonly record struct TweenDeltaArguments(float Delta);
}

